// *** WARNING: this file was generated by pulumi. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***

using System;
using System.Collections.Generic;
using System.Collections.Immutable;
using System.Threading.Tasks;
using Pulumi.Serialization;

namespace Pulumi.Pvecluster
{
    [PveclusterResourceType("pvecluster:index:Cluster")]
    public partial class Cluster : global::Pulumi.CustomResource
    {
        [Output("chunks")]
        public Output<Outputs.ChunkConfig?> Chunks { get; private set; } = null!;

        [Output("config")]
        public Output<Outputs.ClusterConfig?> Config { get; private set; } = null!;

        [Output("connection")]
        public Output<Outputs.Connection> Connection { get; private set; } = null!;

        [Output("deviceClass")]
        public Output<string?> DeviceClass { get; private set; } = null!;

        [Output("name")]
        public Output<string> Name { get; private set; } = null!;

        [Output("nodeIds")]
        public Output<ImmutableArray<string>> NodeIds { get; private set; } = null!;

        [Output("replicas")]
        public Output<int?> Replicas { get; private set; } = null!;

        [Output("status")]
        public Output<string> Status { get; private set; } = null!;


        /// <summary>
        /// Create a Cluster resource with the given unique name, arguments, and options.
        /// </summary>
        ///
        /// <param name="name">The unique name of the resource</param>
        /// <param name="args">The arguments used to populate this resource's properties</param>
        /// <param name="options">A bag of options that control this resource's behavior</param>
        public Cluster(string name, ClusterArgs args, CustomResourceOptions? options = null)
            : base("pvecluster:index:Cluster", name, args ?? new ClusterArgs(), MakeResourceOptions(options, ""))
        {
        }

        private Cluster(string name, Input<string> id, CustomResourceOptions? options = null)
            : base("pvecluster:index:Cluster", name, null, MakeResourceOptions(options, id))
        {
        }

        private static CustomResourceOptions MakeResourceOptions(CustomResourceOptions? options, Input<string>? id)
        {
            var defaultOptions = new CustomResourceOptions
            {
                Version = Utilities.Version,
            };
            var merged = CustomResourceOptions.Merge(defaultOptions, options);
            // Override the ID if one was specified for consistency with other language SDKs.
            merged.Id = id ?? merged.Id;
            return merged;
        }
        /// <summary>
        /// Get an existing Cluster resource's state with the given name, ID, and optional extra
        /// properties used to qualify the lookup.
        /// </summary>
        ///
        /// <param name="name">The unique name of the resulting resource.</param>
        /// <param name="id">The unique provider ID of the resource to lookup.</param>
        /// <param name="options">A bag of options that control this resource's behavior</param>
        public static Cluster Get(string name, Input<string> id, CustomResourceOptions? options = null)
        {
            return new Cluster(name, id, options);
        }
    }

    public sealed class ClusterArgs : global::Pulumi.ResourceArgs
    {
        [Input("chunks")]
        public Input<Inputs.ChunkConfigArgs>? Chunks { get; set; }

        [Input("config")]
        public Input<Inputs.ClusterConfigArgs>? Config { get; set; }

        [Input("connection", required: true)]
        public Input<Inputs.ConnectionArgs> Connection { get; set; } = null!;

        [Input("deviceClass")]
        public Input<string>? DeviceClass { get; set; }

        [Input("name", required: true)]
        public Input<string> Name { get; set; } = null!;

        [Input("nodeIds", required: true)]
        private InputList<string>? _nodeIds;
        public InputList<string> NodeIds
        {
            get => _nodeIds ?? (_nodeIds = new InputList<string>());
            set => _nodeIds = value;
        }

        [Input("replicas")]
        public Input<int>? Replicas { get; set; }

        public ClusterArgs()
        {
        }
        public static new ClusterArgs Empty => new ClusterArgs();
    }
}
